#include<bits/stdc++.h>
using namespace std;
#define N 500005
inline int read()
{
	int x=0,f=1;
	char ch=getchar();
	while(ch<'0'||ch>'9')
	{
		if(ch=='-') f=-1;
		ch=getchar();
	}
	while(ch>='0'&&ch<='9')
	{
		x=(x<<1)+(x<<3)+(ch^48);
		ch=getchar();
	}
	return x*f;
}
int n,q,cnt,u,v,l,r,k,ans;
int a[N],dfn[N],dep[N],f[N][20],lg[N],gn[N][20],gx[N][20];
vector<int> g[N];
void dfs(int x,int fa)
{
	dfn[x]=++cnt,a[cnt]=x,dep[x]=dep[fa]+1,f[x][0]=fa;
	for(int i=1;i<20;i++) f[x][i]=f[f[x][i-1]][i-1];
	for(auto i:g[x])
		if(i^fa) dfs(i,x);
}
int lca(int x,int y)
{
	if(x==y) return x;
	if(dep[x]>dep[y]) swap(x,y);
	int tmp=dep[y]-dep[x];
	for(int i=19;i>=0;i--)
		if((tmp>>i)&1) y=f[y][i];
	if(x==y) return x;
	for(int i=19;i>=0;i--)
		if(f[x][i]!=f[y][i]) x=f[x][i],y=f[y][i];
	return f[x][0];
}
int query1(int l,int r)
{
	int x=lg[r-l+1];
	return min(gn[l][x],gn[r-(1<<x)+1][x]);
}
int query2(int l,int r)
{
	int x=lg[r-l+1];
	return max(gx[l][x],gx[r-(1<<x)+1][x]);
}
int main()
{
	freopen("query.in","r",stdin);
	freopen("query.out","w",stdout);
	memset(gn,0x3f,sizeof(gn)); 
	n=read();
	for(int i=1;i<n;i++)
	{
		u=read(),v=read();
		g[u].push_back(v);
		g[v].push_back(u);
	}
	dfs(1,0);
	for(int i=2;i<=n;i++) lg[i]=lg[i>>1]+1;
	for(int i=1;i<=n;i++) gn[i][0]=gx[i][0]=dfn[i];
	for(int i=1;i<20;i++)
	{
		for(int j=1;j+(1<<i)-1<=n;j++)
			gn[j][i]=min(gn[j][i-1],gn[j+(1<<i-1)][i-1]),gx[j][i]=max(gx[j][i-1],gx[j+(1<<i-1)][i-1]);
	}
	q=read();
	while(q--)
	{
		ans=0;
		l=read(),r=read(),k=read();
		for(int i=l;i+k-1<=r;i++)
		{
			u=a[query1(i,i+k-1)],v=a[query2(i,i+k-1)];
			ans=max(ans,dep[lca(u,v)]);
		}
		printf("%d\n",ans);
	}
	return 0;
}
